plot.irf.VAR <- function (x, varnames = NULL, ...) 
{
    impulses <- x$mhat
    m <- dim(impulses)[1]
    nsteps <- dim(impulses)[3]
    stacked.impulses <- t(matrix(impulses, m^2, nsteps))
    stacked.impulses <- matrix(stacked.impulses, nsteps * m, 
        m)
    dim(impulses) <- c((m^2), nsteps)
    impulses <- ts(t(impulses), start = c(0, 1), freq = 1)
    minmax <- apply(stacked.impulses, 2, range)
    j <- 1
    par(mfrow = c(m, m)) #, #mai = c(0.25, 0.25, 0.15, 0.25), 
#    	omi = c(0.15, 0.75, 1, 0.15))
    for (i in 1:m^2) {
        plot(impulses[, i], xlab = "", ylab = "", ylim = c(minmax[, 
            ceiling(i/m)]))
        abline(h = 0)
#        if (i <= m) {
#            mtext(varnames[i], side = 3, line = 2)
#        }
#        if ((i - 1)%%m == 0) {
#            mtext(varnames[j], side = 2, line = 3)
#            j <- j + 1
#        }
    }
#    mtext("Shock to", side = 3, line = 3, outer = T)
#    mtext("Response in", side = 2, line = 3, , outer = T)
}
